#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

MODULE = File::Stat::Manip		PACKAGE = File::Stat::Manip

int
st_size()
    CODE:
    RETVAL = sizeof(Stat_t);
    OUTPUT:
    RETVAL

void
save()
    PPCODE:
    SV *rv = sv_newmortal();
    EXTEND(SP, 1);
    if(PL_laststatval == 0) {
	sv_setref_pvn(rv, "File::Stat::Manip",
	    (char *)&PL_statcache, sizeof(Stat_t));
	PUSHs(rv);
    }

SV *
stat_name(...)
    CODE:
    RETVAL = newSVsv(PL_statname);
    if(items == 1)
	sv_setpv(PL_statname, SvPV_nolen(ST(0)));
    OUTPUT:
    RETVAL

void
_fake(...)
    PREINIT:
	Stat_t	statbuf;
	SV *rv = sv_newmortal();
    PPCODE:
    if (items != 13)
	Perl_croak(aTHX_ "_fake needs 13 items");
#ifdef USE_STAT_BLOCKS
    statbuf.st_blocks = (UV) POPi;
    statbuf.st_blksize = (UV) POPi;
#else
    (void) POPi;
    (void) POPi;
#endif
#ifdef BIG_TIME
    statbuf.st_ctime = POPn;
    statbuf.st_mtime = POPn;
    statbuf.st_atime = POPn;
#else
    statbuf.st_ctime = POPi;
    statbuf.st_mtime = POPi;
    statbuf.st_atime = POPi;
#endif
#if Off_t_size > IVSIZE
    statbuf.st_size = POPn;
#else
    statbuf.st_size = POPi;
#endif
#ifdef USE_STAT_RDEV
    statbuf.st_rdev = POPi;
#else
    (void) POPi;
#endif
#if Gid_t_size > IVSIZE
    statbuf.st_gid = POPn;
#else
# if Gid_t_sign <= 0
    statbuf.st_gid = POPi;
# else
    statbuf.st_gid = (UV) POPi;
# endif
#endif
#if Uid_t_size > IVSIZE
    statbuf.st_uid = POPn;
#else
# if Uid_t_sign <= 0
    statbuf.st_uid = POPi;
# else
    statbuf.st_uid = (UV) POPi;
# endif
#endif
    statbuf.st_nlink = (UV) POPi;
    statbuf.st_mode = (UV) POPi;
    statbuf.st_ino = POPi;
    statbuf.st_dev = POPi;
    sv_setref_pvn(rv, "File::Stat::Manip",
	(char *)&statbuf, sizeof(Stat_t));
    PUSHs(rv);

void
restore(sv)
    SV *sv;
    CODE:
    if(sv_isa(sv, "File::Stat::Manip")) {
	STRLEN sz;
	char *buf = SvPV((SV*)SvRV(sv), sz);
	if(sz != sizeof(Stat_t)) {
	    Perl_croak(aTHX_ "Corrupt sv, size %d, need %d",
		sz, sizeof(Stat_t));
	}
	Copy(buf,&PL_statcache, 1, Stat_t);
	PL_laststatval = 0;
    } else
	Perl_croak(aTHX_ "sv is not a File::Stat::Manip");


